package org.jeecg.modules.stm.audit.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.audit.entity.AuditInnerCheckmethod;
import org.jeecg.modules.stm.audit.service.IAuditInnerCheckmethodService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 内控制度检查方法
 * @Author: jeecg-boot
 * @Date:   2025-03-19
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/audit/auditInnerCheckmethod")
@Slf4j
public class AuditInnerCheckmethodController extends JeecgController<AuditInnerCheckmethod, IAuditInnerCheckmethodService> {
	@Autowired
	private IAuditInnerCheckmethodService auditInnerCheckmethodService;
	
	/**
	 * 分页列表查询
	 *
	 * @param auditInnerCheckmethod
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "内控制度检查方法-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<AuditInnerCheckmethod>> queryPageList(AuditInnerCheckmethod auditInnerCheckmethod,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AuditInnerCheckmethod> queryWrapper = QueryGenerator.initQueryWrapper(auditInnerCheckmethod, req.getParameterMap());
		Page<AuditInnerCheckmethod> page = new Page<AuditInnerCheckmethod>(pageNo, pageSize);
		IPage<AuditInnerCheckmethod> pageList = auditInnerCheckmethodService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param auditInnerCheckmethod
	 * @return
	 */
	@AutoLog(value = "内控制度检查方法-添加")
	  
	@RequiresPermissions("audit:audit_inner_order_checkmethod:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody AuditInnerCheckmethod auditInnerCheckmethod) {
		auditInnerCheckmethodService.save(auditInnerCheckmethod);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param auditInnerCheckmethod
	 * @return
	 */
	@AutoLog(value = "内控制度检查方法-编辑")
	  
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody AuditInnerCheckmethod auditInnerCheckmethod) {
		auditInnerCheckmethodService.updateById(auditInnerCheckmethod);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "内控制度检查方法-通过id删除")
	  
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		auditInnerCheckmethodService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "内控制度检查方法-批量删除")
	  
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.auditInnerCheckmethodService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "内控制度检查方法-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<AuditInnerCheckmethod> queryById(@RequestParam(name="id",required=true) String id) {
		AuditInnerCheckmethod auditInnerCheckmethod = auditInnerCheckmethodService.getById(id);
		if(auditInnerCheckmethod==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(auditInnerCheckmethod);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param auditInnerCheckmethod
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AuditInnerCheckmethod auditInnerCheckmethod) {
        return super.exportXls(request, auditInnerCheckmethod, AuditInnerCheckmethod.class, "内控制度检查方法");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AuditInnerCheckmethod.class);
    }


	 @GetMapping(value = "/findAllInnerOrderChecks")
	 public Result<List<Map<String,Object>>> findAllInnerOrderChecks(AuditInnerCheckmethod auditCheckMethod) {
		 List<Map<String,Object>> list = auditInnerCheckmethodService.getAllInnerOrderCheckMethod(auditCheckMethod);
		 return Result.OK(list);
	 }

}
